/****************************************************************************
 * The Fifth ICFP Programming Contest entry
 * Copyright (C) 2002  Dragan Tubic
 * tdragan@gel.ulaval.ca
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ****************************************************************************/
//---------------------------------------------------------------------------
#pragma hdrstop
#include <iostream>
#include <stdexcept>
#include <string>
#include <strstream>
#include "contest.h"
#include "brain.h"
//---------------------------------------------------------------------------
using namespace std;
//---------------------------------------------------------------------------
#pragma argsused
int main(int argc, char* argv[])
{
    if ( argc < 3 )
    {
        cout << "Invalid arguments!" << endl;
        cout << "  Usage: robot hostname port" << endl << endl;
        return 1;
    }

    strstream tmp;
    tmp << argv[2];

    int port;
    tmp >> port;

    string hostname = argv[1];
    cout << argv[2] << "...";
    cout << "Trying to contact: " << hostname << " at port " << port << endl;

    Brain mBrain;

    mBrain.Init( hostname, port );

    bool alive = true;
    try{
    while ( alive )
    {
        cout << "Turn starts." << endl;

        int no_pack = mBrain.mServer.UpdatePackages( mBrain.mPackages, mBrain.mRobots[0].x, mBrain.mRobots[0].y );
        int no_cp = mBrain.mPickedPackages.size();
        int goal = mBrain.mGoal;
        cout << "Id: " << mBrain.mRobots[0].id << ", no_pack = " << no_pack << ", carring: " << no_cp << ", goal " << goal << endl;

        mBrain.MakeStep();

        bool alive = mBrain.mServer.UpdateRobots( mBrain.mRobots, mBrain.mPackages, mBrain.mPickedPackages );
        if ( !alive )
        {
            cout << "I am dead!" << endl;
            string tmp_str;
            mBrain.mServer.ReadLine( tmp_str );
            cout << tmp_str << endl;
            mBrain.mServer.ReadLine( tmp_str );
            cout << tmp_str << endl;
            mBrain.mServer.ReadLine( tmp_str );
            cout << tmp_str << endl;
            mBrain.mServer.Close();
            alive = false;
        }
    }
    } catch ( runtime_error& e )
    {
        cout << e.what() << endl;
    }
    return 0;
}
//---------------------------------------------------------------------------
